from enum import Enum


class ErrorCode(Enum):
    OK = 0x00000000
    INVALID_TIME = 100
    ERROR_READ_PKCS12 = 0x08F00002
    ERROR_OPEN_PKCS12 = 0x08F00003
    INVALID_PROPID = 0x08F00004
    BUFFER_TOO_SMALL = 0x08F00005
    CERT_PARSE_ERROR = 0x08F00006
    INVALID_FLAG = 0x08F00007
    OPENFILEERR = 0x08F00008
    INVALIDPASSWORD = 0x08F00009
    MEMORY_ERROR = 0x08F0000D
    CHECKCHAINERROR = 0x08F0000E
    VALIDTYPEERROR = 0x08F00010
    BADCRLFORMAT = 0x08F00011
    LOADCRLERROR = 0x08F00012
    LOADCRLSERROR = 0x08F00013
    UNKNOWN_ALG = 0x08F00015
    KEYNOTFOUND = 0x08F00016
    SIGN_INIT_ERROR = 0x08F00017
    SIGN_ERROR = 0x08F00018
    ENCODE_ERROR = 0x08F00019
    INVALID_FLAGS = 0x08F0001A
    CERTNOTFOUND = 0x08F0001B
    VERIFYSIGNERROR = 0x08F0001C
    BASE64_DECODE_ERROR = 0x08F0001D
    UNKNOWN_CMS_FORMAT = 0x08F0001E
    CA_CERT_NOT_FOUND = 0x08F00020
    XMLSECINIT_ERROR = 0x08F00021
    LOADTRUSTEDCERTSERR = 0x08F00022
    SIGN_INVALID = 0x08F00023
    NOSIGNFOUND = 0x08F00024
    DECODE_ERROR = 0x08F00025
    XMLPARSEERROR = 0x08F00026
    XMLADDIDERROR = 0x08F00027
    XMLINTERNALERROR = 0x08F00028
    XMLSETSIGNERROR = 0x08F00029
    OPENSSLERROR = 0x08F0002A
    NOTOKENFOUND = 0x08F0002C
    OCSP_ADDCERTERR = 0x08F0002D
    OCSP_PARSEURLERR = 0x08F0002E
    OCSP_ADDHOSTERR = 0x08F0002F
    OCSP_REQERR = 0x08F00030
    OCSP_CONNECTIONERR = 0x08F00031
    VERIFY_NODATA = 0x08F00032
    IDATTR_NOTFOUND = 0x08F00033
    IDRANGE = 0x08F00034
    READERNOTFOUND = 0x08F00037
    GETCERTPROPERR = 0x08F00038
    SIGNFORMMAT = 0x08F00039
    INDATAFORMAT = 0x08F0003A
    OUTDATAFORMAT = 0x08F0003B
    VERIFY_INIT_ERROR = 0x08F0003C
    VERIFY_ERROR = 0x08F0003D
    HASH_ERROR = 0x08F0003E
    SIGNHASH_ERROR = 0x08F0003F
    CACERTNOTFOUND = 0x08F00040
    CERTTIMEINVALID = 0x08F00042
    CONVERTERROR = 0x08F00043
    TSACREATEQUERY = 0x08F00044
    CREATEOBJ = 0x08F00045
    CREATENONCE = 0x08F00046
    HTTPERROR = 0x08F00047
    CADESBES_FAILED = 0x08F00048
    CADEST_FAILED = 0x08F00049
    NOTSATOKEN = 0x08F0004A
    INVALID_DIGEST_LEN = 0x08F0004B
    GENRANDERROR = 0x08F0004C
    SOAPNSERROR = 0x08F0004D
    GETPUBKEY = 0x08F0004E
    GETCERTINFO = 0x08F0004F
    FILEREADERROR = 0x08F00050
    CHECKERROR = 0x08F00051
    ZIPEXTRACTERR = 0x08F00052
    NOMANIFESTFILE = 0x08F00053
    VERIFY_TS_HASH = 0x08F00054
    XADEST_FAILED = 0x08F00055
    OCSP_RESP_STAT_MALFORMEDREQUEST = 0x08F00056
    OCSP_RESP_STAT_INTERNALERROR = 0x08F00057
    OCSP_RESP_STAT_TRYLATER = 0x08F00058
    OCSP_RESP_STAT_SIGREQUIRED = 0x08F00059
    OCSP_RESP_STAT_UNAUTHORIZED = 0x08F0005A
    VERIFY_ISSUERSERIALV2 = 0x08F0005B
    OCSP_CHECKCERTFROMRESP = 0x08F0005C
    CRLEXPIRED = 0x08F0005D
    LIBRARYNOTINITIALIZED = 0x08F00101
    ENGINELOADERR = 0x08F00200
    PARAM_ERROR = 0x08F00300
    CERT_STATUS_OK = 0x08F00400
    CERT_STATUS_REVOKED = 0x08F00401
    CERT_STATUS_UNKNOWN = 0x08F00402


class ErrorMessage(Enum):
    OK = "Нет ошибки"
    INVALID_TIME = "Некорректное время"
    ERROR_READ_PKCS12 = "Невозможно прочитать файл формата pkcs#12"
    ERROR_OPEN_PKCS12 = "Невозможно открыть файл формата pkcs12"
    INVALID_PROPID = "Недопустимый идентификатор расширения сертификата"
    BUFFER_TOO_SMALL = "Размер буфера слишком мал"
    CERT_PARSE_ERROR = "Невозможно разобрать (распарсить) сертификат"
    INVALID_FLAG = "Недопустимый флаг"
    OPENFILEERR = "Невозможно открыть файл"
    INVALIDPASSWORD = "Неправильный пароль"
    MEMORY_ERROR = "Невозможно выделить память"
    CHECKCHAINERROR = (
        "Не найден сертификат УЦ или сертификат пользователя при проверки цепочки"
    )
    VALIDTYPEERROR = "Недопустимый тип валидации сертификата"
    BADCRLFORMAT = "Некорректный формат CRL"
    LOADCRLERROR = "Невозможно загрузить CRL"
    LOADCRLSERROR = "Невозможно загрузить CRL-ы"
    UNKNOWN_ALG = "Неизвестный алгоритм подписи"
    KEYNOTFOUND = "Не найден приватный ключ пользователя"
    SIGN_INIT_ERROR = "Невозможно инициализировать менеджера подписи"
    SIGN_ERROR = "Не удалось сгенерировать цифровую подпись"
    ENCODE_ERROR = "Ошибка шифрования"
    INVALID_FLAGS = "Недопустимые флаги"
    CERTNOTFOUND = "Не найден сертификат пользователя"
    VERIFYSIGNERROR = "Ошибка верификации подписи xml"
    BASE64_DECODE_ERROR = "Ошибка дешифровки из Base 64"
    UNKNOWN_CMS_FORMAT = "Неизвестный формат CMS"
    CA_CERT_NOT_FOUND = "Не найден сертификат УЦ"
    XMLSECINIT_ERROR = "Ошибка инициализации xmlsec"
    LOADTRUSTEDCERTSERR = "Ошибка загрузки доверенных сертификатов"
    SIGN_INVALID = "Недопустимая подпись xml"
    NOSIGNFOUND = "Не найдена подпись во входных данных"
    DECODE_ERROR = "Ошибка дешифрования"
    XMLPARSEERROR = "Невозможно разобрать (распарсить) xml"
    XMLADDIDERROR = "Не удалось добавить атрибут ID"
    XMLINTERNALERROR = "Ошибка при работе с xml"
    XMLSETSIGNERROR = "Не удалось подписать xml"
    OPENSSLERROR = "Ошибка openssl"
    NOTOKENFOUND = "Не найден токен"
    OCSP_ADDCERTERR = "Не удалось добавить сертификат в ocsp"
    OCSP_PARSEURLERR = "Не удалось разобрать url"
    OCSP_ADDHOSTERR = "Не удалось добавить хост"
    OCSP_REQERR = "Не удалось добавить текущее время в запрос"
    OCSP_CONNECTIONERR = "Ошибка подключения к OCSP респондеру"
    VERIFY_NODATA = "Нет входных данных для верификации"
    IDATTR_NOTFOUND = "Не найден атрибут ID"
    IDRANGE = "Некорректный идентификатор"
    READERNOTFOUND = "Не найден ридер"
    GETCERTPROPERR = "Не удалось получить значение атрибута"
    SIGNFORMMAT = "Неизвестный формат подписи"
    INDATAFORMAT = "Неизвестный формат входных данных"
    OUTDATAFORMAT = "Неизвестный формат выходных данных"
    VERIFY_INIT_ERROR = "Невозможно инициализировать менеджера верификации подписи"
    VERIFY_ERROR = "Не удалось верифицировать цифровую подпись"
    HASH_ERROR = "Не удалось хэшировать данные"
    SIGNHASH_ERROR = "Не удалось подписать хэшированные данные"
    CACERTNOTFOUND = "Не найден сертификат УЦ в хранилище сертификатов"
    CERTTIMEINVALID = "Срок действия сертификата истек либо еще не наступил"
    CONVERTERROR = "Ошибка записи сертификата в структуру X509"
    TSACREATEQUERY = "Ошибка генерации запроса timestamp"
    CREATEOBJ = "Ошибка записи OID в ASN1 структуру"
    CREATENONCE = "Ошибка генерации уникального числа"
    HTTPERROR = "Ошибка протокола http"
    CADESBES_FAILED = "Ошибка проверки расширения CADESBES в CMS"
    CADEST_FAILED = "Ошибка проверки подписи токена TSA"
    NOTSATOKEN = "В подписи не присутствует метка TSA"
    INVALID_DIGEST_LEN = "Неправильная длина хэша"
    GENRANDERROR = "Ошибка генерации случайного числа"
    SOAPNSERROR = "Не найдены заголовки SOAP-сообщений"
    GETPUBKEY = "Ошибка экспорта публичного ключа"
    GETCERTINFO = "Ошибка получения информации о сертификате"
    FILEREADERROR = "Ошибка чтения файла"
    CHECKERROR = "Хэш не совпадает"
    ZIPEXTRACTERR = "Невозможно открыть архив"
    NOMANIFESTFILE = "Не найден MANIFEST"
    VERIFY_TS_HASH = "не удалось проверить Хэш подписи TS"
    XADEST_FAILED = "XAdES-T: Ошибка проверки подписи"
    OCSP_RESP_STAT_MALFORMEDREQUEST = "Неправильный запрос"
    OCSP_RESP_STAT_INTERNALERROR = "Внутренняя ошибка"
    OCSP_RESP_STAT_TRYLATER = "Попробуйте позже"
    OCSP_RESP_STAT_SIGREQUIRED = "Должны подписать запрос"
    OCSP_RESP_STAT_UNAUTHORIZED = "Запрос не авторизован"
    VERIFY_ISSUERSERIALV2 = "не удалось проверить IssuerSerialV2 в XAdES"
    OCSP_CHECKCERTFROMRESP = "Ошибка проверки сертификата OCSP-респондера"
    CRLEXPIRED = "CRL-файл просрочен"
    LIBRARYNOTINITIALIZED = "Библиотека не инициализирована"
    ENGINELOADERR = "Ошибка подключения (загрузки) модуля (engine)"
    PARAM_ERROR = "Некорректные входные данные"
    CERT_STATUS_OK = (
        "Статус сертификата – валидный. (не является ошибкой, делается запись в лог)"
    )
    CERT_STATUS_REVOKED = "Статус сертификата – отозван."
    CERT_STATUS_UNKNOWN = "Статус сертификата – неизвестен. Например, не удалось установить издателя сертификата."
